/*
 * Copyright (c) 2005 DocJava, Inc. All Rights Reserved.
 */
package net.rmi.pawelGrid.LusCs;

import gui.run.RunJob;

import java.util.Collections;
import java.util.Comparator;
import java.util.Vector;

/**
 * Copyright DocJava, inc. User: lyon
 * <p/>
 * Date: May 1, 2005
 * <p/>
 * Time: 3:11:47 PM
 */
public class CsRecords {
    private static Vector v = new Vector();

    public static final double leastTimeInSeconds = 10;

    public CsRecord[] getRecords() {
        CsRecord a[] = new CsRecord[v.size()];
        v.copyInto(a);
        return a;
    }

    public void add(CsRecord r) {
        v.addElement(r);
    }

    public void startScanner() {
        new RunJob(leastTimeInSeconds) {
            public void run() {
                removeOldRecords();
            }
        };
    }

    public void removeOldRecords() {
        CsRecord a[] = getRecords();
        for (int i = 0; i < a.length; i++)
            deleteIfOld(a[i]);
    }

    /**
     * Check to see if the lease has expired
     */
    private void deleteIfOld(CsRecord csRecord) {
        if (csRecord.getAge() > leastTimeInSeconds) {
            removeRecord(csRecord);
        }
    }

    private void removeRecord(CsRecord csr) {
        v.remove(csr);
    }

    public String toString() {
        CsRecord a[] = getRecords();
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < a.length; i++) {
            sb.append(a[i].toString());
            sb.append("\n-------------\n");

        }
        return sb.toString();
    }

    public CsRecord getLeastLoaded() {
        sort();
        return (CsRecord) v.elementAt(0);

    }

    public void sort() {
        Collections.sort(
                v, new CsRecordComparator());
    }

    private static class CsRecordComparator implements Comparator {
        public int compare(Object o, Object o1) {
            CsRecord cs1 = (CsRecord) o;
            CsRecord cs2 = (CsRecord) o1;
            BenchMarkBean bmb1 = cs1.getBmb();
            BenchMarkBean bmb2 = cs2.getBmb();
            return (int) (bmb1.getMflops() - bmb2.getMflops() );
        }

        public boolean equals(Object o) {
            return false;
        }
    }
}
